﻿using System.ComponentModel;
using SqlSugar;
using XF.Domain.Repository;

namespace Hotline.Settings;

[Description("角色数据权限")]
public class RoleTablePermission //: CreationEntity
{
    /// <summary>
    /// 角色ID
    /// </summary>
    public string RoleId { get; set; }

    /// <summary>
    /// 角色Code
    /// </summary>
    public string RoleCode { get; set; }

    [SugarColumn(ColumnDataType = "longtext", IsJson = true)]
    public List<TablePermission> TablePermissions { get; set; }
}


public class TablePermission
{
    /// <summary>
    /// 表权限等级
    /// </summary>
    public ETablePermissionLevel TablePermissionLevel { get; set; }

    /// <summary>
    /// 实体名
    /// </summary>
    public string EntityName { get; set; }
}

public enum ETablePermissionLevel
{
    /// <summary>
    /// 全部可见
    /// </summary>
    [Description("全部可见")]
    All = 0,

    /// <summary>
    /// 本部
    /// </summary>
    [Description("本部门可见")]
    Org = 1,

    /// <summary>
    /// 本部及以下
    /// </summary>
    [Description("本部及下级部门可见")]
    OrgAndBelow = 2,

    /// <summary>
    /// 创建人
    /// </summary>
    [Description("创建人可见")]
    Creator = 3,
}